/* HostServ functions
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 *
 * Based on the original code of Services by Andy Church.
 *
 * HostServ.c - 16/06/2002 - Rob.
 * Fix'ed a minor bug preventing compile on a none VHOST ircd... - 29/06/2002 - Rob
 * lots of code based on that of PegSoft and is (c) Epona 2000-2002
 *
 */
/*************************************************************************/
#include "services.h"
#include "pseudo.h"
#include "hostserv.h"	/* cmd table etc inside .h file */

/*************************************************************************/
/* HostServ initialization. */
void hostserv_init(void)
{
	guestnum = time(NULL);
	while (guestnum>9999999) guestnum -= 10000000;
}
/*************************************************************************/
/* Main HostServ routine. */
void hostserv(User *u, char *buf)
{
    char *cmd, *s;

    cmd = strtok(buf, " ");

    if (!cmd) {
		return;
    } else if (stricmp(cmd, "\1PING") == 0) {
		if (!(s = strtok(NULL, "")))
	    	s = "\1";
		notice(s_HostServ, u->nick, "\1PING %s", s);
    } else if (skeleton) {
		notice_lang(s_HostServ, u, SERVICE_OFFLINE, s_HostServ);
    } else {
		run_cmd(s_HostServ, u, cmds, cmd);
    }
}
/*************************************************************************/
/*	Start of Linked List routines					 */
/*************************************************************************/
HostCore *createHostCorelist(HostCore *next, char *nick, char *vHost, char *creator, int32 tmp_time) {

	next = malloc(sizeof(HostCore));
	if(next==NULL) {
		wallops(s_HostServ, "Unable to allocate memory to create the vHost LL, problems i sense..");
	} else {
		next->nick = malloc(sizeof(char)*strlen(nick)+1);
		next->vHost = malloc(sizeof(char)*strlen(vHost)+1);
		next->creator = malloc(sizeof(char)*strlen(creator)+1);
		if( (next->nick==NULL) || (next->vHost==NULL) || (next->creator==NULL) ) {
			wallops(s_HostServ, "Unable to allocate memory to create the vHost LL, problems i sense..");
			return NULL;
		}
		strcpy(next->nick,nick);
		strcpy(next->vHost,vHost);
		strcpy(next->creator,creator);
		next->time = tmp_time;
		next->next = NULL;
		return next;
	}
	return NULL;
}
/*************************************************************************/
HostCore *findHostCore(HostCore *head, char *nick, boolean *found) {

	HostCore *previous,*current;

	*found = false;
	current = head;
	previous = current;

	while(current!=NULL) {
		if(stricmp(nick,current->nick)==0) {
			*found = true;
			break;
		}
		else if(stricmp(nick,current->nick) < 0) {
			// we know were not gonna find it now....
			break;
		}
		else {
			previous = current;
			current = current->next;
		}
	}
	if(current == head) {
		return NULL;
	}else {
		return previous;
	}
}
/*************************************************************************/
HostCore *insertHostCore(HostCore *head, HostCore *prev, char *nick, char *vHost, char *creator,int32 tmp_time) {

	HostCore *newCore, *tmp;

	newCore = malloc(sizeof(HostCore));
	if(newCore==NULL) {
		wallops(s_HostServ, "Unable to allocate memory to insert into the vHost LL, problems i sense..");
		return NULL;
	} else {
		newCore->nick = malloc(sizeof(char)*strlen(nick)+1);
		newCore->vHost = malloc(sizeof(char)*strlen(vHost)+1);
		newCore->creator = malloc(sizeof(char)*strlen(creator)+1);
		if( (newCore->nick==NULL) || (newCore->vHost==NULL) || (newCore->creator==NULL) ) {
			wallops(s_HostServ, "Unable to allocate memory to create the vHost LL, problems i sense..");
			return NULL;
		}
		strcpy(newCore->nick,nick);
		strcpy(newCore->vHost,vHost);
		strcpy(newCore->creator,creator);
		newCore->time = tmp_time;
		if(prev==NULL) {
			tmp = head;
			head = newCore;
			newCore->next=tmp;
		} else {
			tmp = prev->next;
			prev->next = newCore;
			newCore->next = tmp;
		}
	}
	return head;
}
/*************************************************************************/
HostCore *deleteHostCore(HostCore *head, HostCore *prev) {

	HostCore *tmp;

	if(prev==NULL) {
		tmp = head;
		head = head->next;
	} else {
		tmp = prev->next;
		prev->next = tmp->next;
	}
	free(tmp->vHost); free(tmp->nick); free(tmp->creator);
	free(tmp);
	return head;
}
/*************************************************************************/
void addHostCore(char *nick,char *vhost,char *creator,int32 tmp_time) {
	HostCore *tmp;
	boolean found = false;
	
	if(head==NULL) {
		head = createHostCorelist(head,nick,vhost,creator,tmp_time);
	} else {
		tmp = findHostCore(head, nick, &found);
		if(!found) {
			head = insertHostCore(head,tmp,nick,vhost,creator,tmp_time);
		} else {
			head = deleteHostCore(head,tmp);	// delete the old entry
			addHostCore(nick,vhost,creator,tmp_time);	// recursive call to add new entry
		}
	}
}
/*************************************************************************/
char *getvHost(char *nick) {
	HostCore *tmp;
	boolean found=false;
	tmp = findHostCore(head,nick,&found);
	if(found) {
		if(tmp==NULL)
			return head->vHost;
		else
			return tmp->next->vHost;
	}
	return NULL;
}
/*************************************************************************/
void listOut(User *u) {
	char *key = strtok(NULL, "");
	struct tm *tm;
	char buf[BUFSIZE];

	HostCore *current;
	if(is_services_admin(u)) {
		current = head;
		if(current==NULL)
			notice_lang(s_HostServ, u, HOST_EMPTY);
		else {
			while(current!=NULL) {
				if(key) {
					if( (stricmp(key,current->nick)==0) || (stricmp(key,current->vHost)==0)) {
						tm = localtime(&current->time);
	    					strftime(buf, sizeof(buf), getstring(NULL,STRFTIME_DATE_TIME_FORMAT), tm);
						notice_lang(s_HostServ, u, HOST_ENTRY,current->nick,current->vHost,current->creator,buf);
					}
				} else {
					tm = localtime(&current->time);
	    				strftime(buf, sizeof(buf), getstring(NULL,STRFTIME_DATE_TIME_FORMAT), tm);
					notice_lang(s_HostServ, u, HOST_ENTRY,current->nick,current->vHost,current->creator,buf);
				}
				current = current->next;
			}
		}
	} else {
		notice_lang(s_HostServ, u, HOST_DENIED);
	}
}
/*************************************************************************/
void delHostCore(char *nick) {
	HostCore *tmp;
	boolean found = false;
	tmp = findHostCore(head,nick,&found);
	if(found) {
		head = deleteHostCore(head,tmp);
	}
}
/*************************************************************************/
/*	End of Linked List routines					 */
/*************************************************************************/
/*************************************************************************/
/*	Start of Load/Save routines					 */
/*************************************************************************/
#define SAFE(x) do {					\
    if ((x) < 0) {					\
	if (!forceload)					\
	    fatal("Read error on %s", HostDBName);	\
	failed = 1;					\
	break;						\
    }							\
} while (0)

void load_hs_dbase(void)
{
	dbFILE *f;
	int ver;

	if (!(f = open_db(s_HostServ, HostDBName, "r", HOST_VERSION))) {
		return;
	}
	ver = get_file_version(f);

	if(ver==1) {
		load_hs_dbase_v1(f);
	} else if(ver == 2) {
		load_hs_dbase_v2(f);
	}
	close_db(f);
}

void load_hs_dbase_v1(dbFILE *f) {
	int c;
	int failed = 0;
	int32 tmp;

	char *nick;
	char *vHost;

	tmp = time(NULL);

	while (!failed && (c = getc_db(f)) == 1) {
		log("Attempting to load HS");
		if (c == 1) {
			SAFE(read_string(&nick, f));
			SAFE(read_string(&vHost, f));
			addHostCore(nick,vHost,"Unknown",tmp); // could get a speed increase by not searching the list
			free(nick);		 // as we know the db is in alphabetical order...
			free(vHost);
		} else {
		    fatal("Invalid format in %s %d", HostDBName, c);
		}
	}
}

void load_hs_dbase_v2(dbFILE *f) {
	int c;
	int failed = 0;

	char *nick;
	char *vHost;
	char *creator;
	int32 time;

	while (!failed && (c = getc_db(f)) == 1) {
		log("Attempting to load HS");
		if (c == 1) {
			SAFE(read_string(&nick, f));
			SAFE(read_string(&vHost, f));
			SAFE(read_string(&creator, f));
			SAFE(read_int32(&time, f));
			addHostCore(nick,vHost,creator,time); // could get a speed increase by not searching the list
			free(nick);		 // as we know the db is in alphabetical order...
			free(vHost);
			free(creator);
		} else {
		    fatal("Invalid format in %s %d", HostDBName, c);
		}
	}
}

#undef SAFE
/*************************************************************************/
#define SAFE(x) do {						\
    if ((x) < 0) {						\
	restore_db(f);						\
	log_perror("Write error on %s", HostDBName);		\
	if (time(NULL) - lastwarn > WarningTimeout) {		\
	    wallops(NULL, "Write error on %s: %s", HostDBName,	\
			strerror(errno));			\
	    lastwarn = time(NULL);				\
	}							\
	return;							\
    }								\
} while (0)

void save_hs_dbase(void)
{
	dbFILE *f;
	static time_t lastwarn = 0;
	HostCore *current;

	if (!(f = open_db(s_HostServ, HostDBName, "w", HOST_VERSION)))
		return;

	current = head;
	while(current!=NULL) {
		SAFE(write_int8(1, f));
		SAFE(write_string(current->nick,f));
		SAFE(write_string(current->vHost,f));
		SAFE(write_string(current->creator,f));
		SAFE(write_int32(current->time, f));
		current = current->next;
	}
	SAFE(write_int8(0, f));
	close_db(f);
}
#undef SAFE
/*************************************************************************/
/*	End of Load/Save Functions					 */
/*************************************************************************/
/*************************************************************************/
/*	Start of Generic Functions					 */
/*************************************************************************/
void do_setall(User *u) {

	char *nick = strtok(NULL, " ");
	char *hostmask = strtok(NULL, " ");

	NickAlias *na;
	int32 tmp_time;

	tmp_time = time(NULL);

	if(is_services_oper(u)) {
		if((nick)&&(hostmask)) {
			if((na = findnick(nick))) {
				log("vHost for all nicks in group %s set by %s",nick,u->nick);
				do_hs_sync(na->nc,hostmask,u->nick,tmp_time);
				notice_lang(s_HostServ, u, HOST_SETALL,nick,hostmask);
			} else {
				notice_lang(s_HostServ, u, HOST_NOREG,nick);
			}
		} else {
			notice_lang(s_HostServ, u, HOST_SETALL_SYNTAX,s_HostServ);
		}
	} else {
		notice_lang(s_HostServ, u, HOST_DENIED);
	}
}

void do_hs_sync(NickCore *nc,char *hostmask,char *creator,time_t time) {
	int i;
	NickAlias *na;

	for (i = 0; i < nc->aliases.count; i++) {
		na = nc->aliases.list[i];
		addHostCore(na->nick,hostmask,creator,time);
	}
}

static void do_help(User *u) {
    char *cmd = strtok(NULL, "");

    if (!cmd) {
		notice_help(s_HostServ, u, HOST_HELP, s_HostServ);
		if (is_services_oper(u))
	    		notice_help(s_HostServ, u, HOST_OPER_HELP);
		if (is_services_admin(u))
			notice_help(s_HostServ, u, HOST_ADMIN_HELP);
    } else {
		help_cmd(s_HostServ, u, cmds, cmd);
    }
}
/*************************************************************************/
void do_set(User *u) {
	char *nick = strtok(NULL, " ");
	char *hostmask = strtok(NULL, " ");
	NickAlias *na;
	int32 tmp_time;

	tmp_time = time(NULL);

	if(is_services_oper(u)) {
		if((nick)&&(hostmask)) {
			if((na = findnick(nick))) {
				log("vHost for user %s set by %s",nick,u->nick);
				addHostCore(nick,hostmask,u->nick,tmp_time);
				notice_lang(s_HostServ, u, HOST_SET,nick,hostmask);
			} else {
				notice_lang(s_HostServ, u, HOST_NOREG,nick);
			}
		} else {
			notice_lang(s_HostServ, u, HOST_SET_SYNTAX,s_HostServ);
		}
	} else {
		notice_lang(s_HostServ, u, HOST_DENIED);
	}
}
/*************************************************************************/
void do_on(User *u) {
	NickAlias *na;
	char *vHost;
	if((na = findnick(u->nick))) {
		if (na->status & NS_IDENTIFIED) {
	 		vHost = getvHost(u->nick);
			if(vHost==NULL) {
				notice_lang(s_HostServ, u, HOST_NOT_ASSIGNED);
			}else{
				notice_lang(s_HostServ, u, HOST_ACTIVATED,vHost);
				send_on(u->nick,vHost);

				u->vhost = sstrdup(vHost);

			}
		} else {
			notice_lang(s_HostServ, u, HOST_ID);
		}
	} else {
		notice_lang(s_HostServ, u, HOST_NOT_REGED);
	}
}
/*************************************************************************/
void do_on_id(User *u) {		// we've assumed that the user exists etc..
	char *vHost;			// as were only gonna call this from nsid routine
	vHost = getvHost(u->nick);
	if(vHost!=NULL) {
		notice_lang(s_HostServ, u, HOST_ACTIVATED,vHost);
		send_on(u->nick,vHost);

		u->vhost = sstrdup(vHost);

	}
}
/*************************************************************************/
void do_del(User *u) {
	NickAlias *na;
	char *nick = strtok(NULL, " ");
	if(is_services_oper(u)) {
		if(nick) {
			if((na = findnick(nick))) {
				log("vHost for user %s deleted by %s",nick,u->nick);
				delHostCore(nick);
				notice_lang(s_HostServ, u, HOST_DEL,nick);
			} else {
				notice_lang(s_HostServ, u, HOST_NOREG,nick);
			}
		} else {
			notice_lang(s_HostServ, u, HOST_DEL_SYNTAX,s_HostServ);
		}
	} else {
		notice_lang(s_HostServ, u, HOST_DENIED);
	}
}
/*************************************************************************/
void do_off(User *u) {
	// put any generic code here... :)
	send_off(u);
}
/*************************************************************************/
/*	End of Generic Functions					 */
/*************************************************************************/
/*************************************************************************/
/*	Start of Server Functions					 */
/*************************************************************************/
void send_on(char *nick, char *vhost) {
#ifdef IRC_BAHAMUT
	send_cmd(NULL, "SVSMODE %s +x", nick);
	send_cmd(NULL, "SVSCHGHOST %s %s", nick, vhost);
#endif
#ifdef IRC_ULTIMATE
	send_cmd(ServerName, "CHGHOST %s %s",nick,vhost);  // I _THINK_ this is the same, 100% untested tho
#endif
#ifdef IRC_SEQUANA
	// Dont know sequana's CHGHOST command
#endif
}
/*************************************************************************/
void send_off(User *u) {
#ifdef IRC_BAHAMUT
	send_cmd(NULL, "SVSMODE %s -x", u->nick);
	notice(s_HostServ, u->nick, "Your vHost has been removed.");
        notice(s_HostServ, u->nick, "To restore host cloaking (if your Server Administrator has it enabled) type: /mode <YOURNICK> +x");
#endif
#ifdef IRC_ULTIMATE
	// Dont know untimates re-do host command.
#endif
#ifdef IRC_SEQUANA
	// Dont know sequana re-do host command.
#endif
}
/*************************************************************************/
/*	End of Server Functions						 */
/*************************************************************************/
